<TeXmacs|1.0.6.10>

<style|amsart>

<\body>
  <action|EXPAND|(quail "expand()")>

  <doc-data|<doc-title|center.tm>>

  <\table-of-contents|toc>
    \;
  </table-of-contents>

  <\code>
    @@ buttons

    <with|color|dark red|def> <with|color|blue|expand>():

    \ \ <with|color|dark green|pass>
  </code>

  <section|<verbatim|quailCenter> implementation>

  This module provides 2 main functions: <verbatim|quailPut> and
  <verbatim|quailGet>, used to define <em|global features> for quail, usable
  by all modules.

  <\code>
    @@ py quailCenter

    \;

    <with|color|dark red|class> <with|color|#800080|aQuailCenter>(dict):

    \ \ <with|color|dark red|def> <with|color|blue|__init__>(o):

    \ \ \ \ dict __init__(o)

    \ \ \ \ o itsDatabase = None

    \ \ <with|color|dark red|def> <with|color|blue|__missing__>(o, theKey):

    \ \ \ \ <with|font-family|rm|Try to obtain the item from the alias
    database.>

    \ \ \ \ theQuailDirectory = quailGet("the quail directory")

    \ \ \ \ page = quailGet("the page class")

    \ \ \ \ <with|color|dark green|if> o itsDatabase <with|color|dark
    green|is> None:

    \ \ \ \ \ \ theFile = theQuailDirectory/"resource"/"aliasDB.py"

    \ \ \ \ \ \ <with|color|dark green|try>:

    \ \ \ \ \ \ \ \ o itsDatabase = quailGet("create module")("aliasDB",
    theFile)

    \ \ \ \ \ \ <with|color|dark green|except> OSError:

    \ \ \ \ \ \ \ \ <with|color|dark green|raise> KeyError, theKey

    \ \ \ \ isa, ixs, p = o itsDatabase itsAliasDict[theKey]

    \ \ \ \ ixp, theSectionName = o itsDatabase itsSectionDict[ixs]

    \ \ \ \ thePage = theQuailDirectory/o itsDatabase itsPageDict[ixp]

    \ \ \ \ x = getattr(page(thePage), theSectionName)

    \ \ \ \ <with|color|dark green|for> theAttr <with|color|dark green|in> p:

    \ \ \ \ \ \ x = getattr(x, theAttr)

    \ \ \ \ <with|color|dark green|return> anObjectGetter(x)

    \;

    TheQuailCenter = aQuailCenter() <math|\<leftarrow\>><with|font-family|rm|big
    <verbatim|The> means singleton.>

    \;

    <with|color|dark red|def> <with|color|blue|quailGet>(theFeature, *args,
    **kwd):

    \ \ <with|font-family|rm|Calls the function which was previously
    associated to the feature (by a call>

    \ \ <with|font-family|rm|to <verbatim|quailPut>). Additional arguments
    are passed to the function.>

    \;

    \ \ <with|color|dark green|return> TheQuailCenter[theFeature](*args,
    **kwd)

    \;

    <with|color|dark red|def> <with|color|blue|quailPut>(theFeature,
    theFunction):

    \ \ <with|font-family|rm|Associates a feature (usually a string) to a
    function.>

    \;

    \ \ TheQuailCenter[theFeature] = theFunction

    \;

    <with|color|dark red|class> <with|color|#800080|anObjectGetter>(object):

    \ \ <with|color|dark red|def> <with|color|blue|__init__>(o, obj):

    \ \ \ \ o obj = obj

    \ \ <with|color|dark red|def> <with|color|blue|__call__>(o):

    \ \ \ \ <with|color|dark green|return> o obj

    \;

    <with|color|dark red|def> <with|color|blue|quailPutObject>(feature, obj):

    \ \ quailPut(feature, anObjectGetter(obj))

    \;

    quailPutObject("the quail center", TheQuailCenter)

    \;

    <with|color|dark red|def> <with|color|blue|_quailDirectoryGetter>():

    \ \ <with|color|dark green|from> os path <with|color|dark green|import>
    split <with|color|dark green|as> psplit, join <with|color|dark green|as>
    pjoin

    \ \ theDirectory = psplit(psplit(__file__)[0])[0]

    \ \ thePathFile = pjoin(theDirectory, "resource", "path.py")

    \ \ thePathModule = quailGet("create module")("path", thePathFile)

    \ \ quailPutObject("the path module", thePathModule)

    \ \ path = thePathModule.path

    \ \ quailPutObject("the path class", path)

    \ \ theDirectory = path(theDirectory)

    \ \ quailPutObject("the quail directory", theDirectory)

    \ \ <with|color|dark green|return> theDirectory

    quailPut("the quail directory", _quailDirectoryGetter)

    \;

    <with|color|dark red|def> <with|color|blue|_createModule>(theName,
    theFilePath):

    \ \ <with|color|dark green|from> imp <with|color|dark green|import>
    new_module

    \ \ theModule = new_module(theName)

    \ \ execfile(theFilePath, theModule __dict__)

    \ \ <with|color|dark green|return> theModule

    quailPutObject("create module", _createModule)<with|font-family|rm|
    <math|\<leftarrow\>>put the function as an object>

    \;

    <with|color|dark red|def> <with|color|blue|_pageClassGetter>():

    \ \ <with|color|dark green|from> quail page <with|color|dark
    green|import> page <with|font-family|rm|<math|\<leftarrow\>> change this
    with the first release.>

    \ \ quailPutObject("the page class", page)

    \ \ <with|color|dark green|return> page

    quailPut("the page class", _pageClassGetter)

    \;

    <with|color|dark red|def> <with|color|blue|_pageModuleGetter>(*pathFromQuail):

    \ \ <with|font-family|rm|Returns a module from a python section of
    texmacs page.>

    \ \ <with|font-family|rm|The path must include the path to the texmacs
    file + the section name (without py).>

    \ \ page = quailGet("the page class")

    \ \ thePath = quailGet("the quail directory")

    \ \ <with|color|dark green|for> element <with|color|dark green|in>
    pathFromQuail[:-1]:

    \ \ \ \ thePath /= element

    \ \ pySection = pathFromQuail[-1]

    \ \ theModule = getattr(page(thePath), pySection)

    \ \ <with|color|dark green|return> theModule

    quailPut("get page module", _pageModuleGetter)

    \;

    <with|color|dark red|def> <with|color|blue|_testfileGetter>():

    \ \ <with|color|dark green|try>:

    \ \ \ \ <with|color|dark green|from> doctestfeu <with|color|dark
    green|import> testfile

    \ \ <with|color|dark green|except> ImportError:

    \ \ \ \ <with|color|dark green|from> doctest <with|color|dark
    green|import> testfile

    \ \ quailPutObject("the testfile utility", testfile)

    \ \ <with|color|dark green|return> testfile

    quailPut("the testfile utility", _testfileGetter)

    \;

    <with|color|dark red|def> <with|color|blue|_fileLoggerGetter>(theFilePath=None):

    \ \ <with|color|dark green|if> theFilePath <with|color|dark green|is>
    None:

    \ \ \ \ <with|color|dark green|return> _fileLoggerGetter

    \ \ <with|color|dark green|from> simplelog <with|color|dark green|import>
    getSimpleLogger <with|font-family|rm|<math|\<leftarrow\>> change this
    with the first release.>

    \ \ <with|color|dark green|return> getSimpleLogger(theFilePath)

    quailPut("get file logger", _fileLoggerGetter)

    \;

    <with|color|dark red|def> <with|color|blue|_declareAliasGetter>():

    \ \ theModule = quailGet("get page module", "alias.tm", "alias")

    \ \ theFunc = theModule doDeclareAlias

    \ \ quailPutObject("do declare alias", theFunc)

    \ \ <with|color|dark green|return> theFunc

    quailPut("do declare alias", _declareAliasGetter)

    \;

    doDeclareAlias = quailGet("do declare alias")

    \;

    <with|color|dark red|def> <with|color|blue|_genQuailTexmacsSources>():

    \ \ quailDir = quailGet("the quail directory")

    \ \ spec = quailDir/"specification"

    \ \ <with|color|dark green|for> name <with|color|dark green|in> quailDir
    files("*.tm"):

    \ \ \ \ <with|color|dark green|yield> name

    \ \ <with|color|dark green|for> dir <with|color|dark green|in> quailDir
    walkdirs():

    \ \ \ \ <with|color|dark green|if> <with|color|dark green|not>
    dir.startswith(spec):

    \ \ \ \ \ \ <with|color|dark green|for> name <with|color|dark green|in>
    dir walkfiles("*.tm"):

    \ \ \ \ \ \ \ \ <with|color|dark green|yield> name

    \;

    <with|color|dark red|def> <with|color|blue|_allQuailTexmacsSources>():

    \ \ <with|color|dark green|return> list(_genQuailTexmacsSources())

    quailPut("all quail texmacs sources", _allQuailTexmacsSources)

    \;
  </code>

  <action|EXPAND|(quail "expand()")>
</body>

<\initial>
  <\collection>
    <associate|bg-color|#e0e0e0>
    <associate|language|english>
    <associate|magnification|1.1>
    <associate|page-type|# Simply write the paper name. See papersize(5) for
    possible values.>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|auto-1|<tuple|?|?>>
    <associate|auto-2|<tuple|1|?>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|toc>
      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|Table
      of contents> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-1><vspace|0.5fn>

      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|1.<space|2spc><with|font-family|<quote|tt>|language|<quote|verbatim>|quailCenter>
      implementation> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-2><vspace|0.5fn>
    </associate>
  </collection>
</auxiliary>