<TeXmacs|1.0.6.10>

<style|amsart>

<\body>
  <action|EXPAND|(quail "expand()")>

  <doc-data|<doc-title|testManager.tm>>

  <\table-of-contents|toc>
    <vspace*|1fn><with|font-series|bold|math-font-series|bold|Table of
    contents> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
    <no-break><pageref|auto-1><vspace|0.5fn>
  </table-of-contents>

  <\code>
    @@ buttons

    <with|color|dark red|def> <with|color|blue|expand>():

    \ \ <with|color|dark green|pass>
  </code>

  <section|The test manager>

  This page, defines a singleton object, the test manager, which role is to
  help in executing quail's tests. As a first feature, it can load fixture
  files and write output files.

  <\code>
    @@ py testManager

    <with|color|dark green|from> quailCenter import quailGet, doDeclareAlias

    doDeclareAlias("", "the test manager module")

    theQuailDirectory = quailGet("the quail directory")

    \;

    \;

    <with|color|dark red|class> <with|color|#800080|_aTestManager>(object):

    \ \ <with|font-family|rm|A singleton class to help managing quail's
    test.>

    \ \ <with|color|dark red|def> <with|color|blue|__init__>(o):

    \ \ \ \ <with|color|dark green|pass>

    \ \ @property

    \ \ <with|color|dark red|def> <with|color|blue|fixture>(o):

    \ \ \ \ <with|color|dark green|return>
    theQuailDirectory/"specification"/"fixture"

    \ \ @property

    \ \ <with|color|dark red|def> <with|color|blue|output>(o):

    \ \ \ \ <with|color|dark green|return>
    theQuailDirectory/"specification"/"output"

    \ \ <with|color|dark red|def> <with|color|blue|loadFixture>(o, name):

    \ \ \ \ fileIn = open(o fixture/name)

    \ \ \ \ content = fileIn.read()

    \ \ \ \ fileIn.close()

    \ \ \ \ <with|color|dark green|return> content

    \ \ <with|color|dark red|def> <with|color|blue|dumpOutput>(o, name,
    content):

    \ \ \ \ fileOut = open(o output/name, "w")

    \ \ \ \ fileOut.write(content)

    \ \ \ \ fileOut.close()

    \;

    TheTestManager = _aTestManager() <with|font-family|rm|<math|\<leftarrow\>>
    the singleton instance.>

    doDeclareAlias("TheTestManager", "the test manager")

    \;
  </code>

  \;

  <action|EXPAND|(quail "expand()")>
</body>

<\initial>
  <\collection>
    <associate|bg-color|#e0e0e0>
    <associate|language|english>
    <associate|magnification|1.1>
    <associate|page-type|# Simply write the paper name. See papersize(5) for
    possible values.>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|auto-1|<tuple|?|?>>
    <associate|auto-2|<tuple|1|?>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|toc>
      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|Table
      of contents> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-1><vspace|0.5fn>

      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|1.<space|2spc>The
      test manager> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-2><vspace|0.5fn>
    </associate>
  </collection>
</auxiliary>