<TeXmacs|1.0.6.10>

<style|amsart>

<\body>
  <action|EXPAND|(quail "expand()")>

  <doc-data|<doc-title|tree.tm>>

  <\table-of-contents|toc>
    <vspace*|1fn><with|font-series|bold|math-font-series|bold|Table of
    contents> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
    <no-break><pageref|auto-1><vspace|0.5fn>

    <vspace*|1fn><with|font-series|bold|math-font-series|bold|1.<space|2spc><with|font-family|tt|language|verbatim|aTmTree>
    objects> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
    <no-break><pageref|auto-2><vspace|0.5fn>

    <with|par-left|1.5fn|1.1.<space|2spc>Base tree classes
    <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
    <no-break><pageref|auto-3>>

    <with|par-left|1.5fn|1.2.<space|2spc>Automatic creation of other tree
    classes <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
    <no-break><pageref|auto-4>>
  </table-of-contents>

  <\code>
    @@ buttons

    <with|color|dark red|def> <with|color|blue|expand>():

    \ \ <with|color|dark green|pass>
  </code>

  <section|<verbatim|aTmTree> objects>

  Trees created from texmacs documents will be stored as <verbatim|aTmTree>
  objects. Each such tree is an instance of <verbatim|list> and it's elements
  are either other <verbatim|aTmTree> instances, or strings (instances of
  <verbatim|str>). The nature of an element can be checked in a fast way with
  the <verbatim|title> attribute. For <verbatim|str> objects,
  <verbatim|title> is a builtin method of the class <verbatim|str>. The tree
  class implements a <verbatim|title> attribute with value <verbatim|False>,
  so that the expression <verbatim|elt.title> will return a false value for a
  tree and a non false value for a string.

  <subsection|Base tree classes>

  <\code>
    @@ py tree

    <with|color|dark green|from> quailCenter <with|color|dark green|import>
    quailGet, doDeclareAlias

    doDeclareAlias("", "the texmacs tree module")

    doDeclareAlias("aTmTree.tmTagToWord", "texmacs tag to word")

    doDeclareAlias("aTmTree.wordToTmTag", "word to texmacs tag")

    <with|color|dark green|from> collections <with|color|dark green|import>
    deque

    \;

    <with|color|dark red|class> <with|color|#800080|aTmTree>(list):

    \ \ <with|font-family|rm|Base class for texmacs trees>

    \ \ title = False <with|font-family|rm|Used to differentiate tree nodes
    from leaves (<verbatim|str>).>

    \ \ isVertical = False <with|font-family|rm|Some trees are displayed
    vertically in a texmacs file.>

    \ \ isCode = False <with|font-family|rm|Overloaded in subclass
    <verbatim|tm_code>.>

    \ \ isWith = False <with|font-family|rm|Overloaded in subclass
    <verbatim|tm_with>.>

    \ \ isConcat = False <with|font-family|rm|Overloaded in subclass
    <verbatim|tm_concat>.>

    \ \ isDocument = False <with|font-family|rm|Overloaded in subclass
    <verbatim|tm_document>.>

    \ \ isCollection = False <with|font-family|rm|Overloaded in subclass
    <verbatim|tm_collection.>>

    \;

    \ \ @staticmethod

    \ \ <with|color|dark red|def> <with|color|blue|tmTagToWord>(theTag):

    \ \ \ \ <with|font-family|rm|Converts a texmacs tag to a word usable as a
    tree class name.>

    \ \ \ \ <with|font-family|rm|The tag is prefixed with <verbatim|tm_var_>
    if it ends with a <verbatim|*> and by <verbatim|tm_> otherwise.>

    \ \ \ \ r = "_" join(theTag split("-"))

    \ \ \ \ <with|color|dark green|return> ("tm_var_" + r[:-1])
    <with|color|dark green|if> (r[-1] == "*") <with|color|dark green|else>
    ("tm_" + r)

    \;

    \ \ @staticmethod

    \ \ <with|color|dark red|def> <with|color|blue|wordToTmTag>(word):

    \ \ \ \ <with|font-family|rm|Converts a tree class name to a texmacs
    tag.>

    \ \ \ \ r = (word[7:] + "*") <with|color|dark green|if>
    word.startswith("tm_var_") <with|color|dark green|else> word[3:]

    \ \ \ \ <with|color|dark green|return> "-" join(r split("_"))

    \;

    \ \ <with|color|dark red|def> <with|color|blue|itsPrettyFormat>(o,
    theIndentation=""):

    \ \ \ \ L = [theIndentation, o __class__ __name__, " [\\n"]

    \ \ \ \ theChildIndentation = theIndentation + " "

    \ \ \ \ <with|color|dark green|for> theElement <with|color|dark green|in>
    o:

    \ \ \ \ \ \ <with|color|dark green|if> theElement title:

    \ \ \ \ \ \ \ \ L.extend((theChildIndentation, repr(theElement), "\\n"))

    \ \ \ \ \ \ <with|color|dark green|else>:

    \ \ \ \ \ \ \ \ L.append(theElement itsPrettyFormat(theChildIndentation))

    \ \ \ \ L.extend((theIndentation, "]\\n"))

    \ \ \ \ <with|color|dark green|return> "" join(L)

    \;

    \ \ <with|color|dark red|def> <with|color|blue|__eq__>(o, other):

    \ \ \ \ <with|font-family|rm|Define equality of trees>

    \ \ \ \ <with|color|dark green|return> o itsPrettyFormat() == other
    itsPrettyFormat()

    \;

    \ \ <with|color|dark red|def> <with|color|blue|itsPrefixDescent>(o,
    cutDescent=None, withRoot=True):

    \ \ \ \ <with|font-family|rm|Generator of the sequence of all nodes and
    leaves in prefix order,>

    \ \ \ \ <with|font-family|rm|with or without the root node, depending on
    the value of <verbatim|withRoot>.>

    \ \ \ \ <with|font-family|rm|The option <verbatim|cutDescent> can be a
    callable object, wich returns <verbatim|True> if the>

    \ \ \ \ <with|font-family|rm|strict descent of a node must be omitted and
    <verbatim|False> otherwise.>

    \;

    \ \ \ \ theStack = deque()

    \ \ \ \ getattr(theStack, "append" <with|color|dark green|if> withRoot
    <with|color|dark green|else> "extend")(o)

    \ \ \ \ <with|color|dark green|while> theStack:

    \ \ \ \ \ \ theNode = theStack popleft()

    \ \ \ \ \ \ <with|color|dark green|yield> theNode

    \ \ \ \ \ \ <with|color|dark green|if> theNode title <with|color|dark
    green|or> (cutDescent <with|color|dark green|and> cutDescent(theNode)):

    \ \ \ \ \ \ \ \ <with|color|dark green|continue>

    \ \ \ \ \ \ theStack extendleft(reversed(theNode))

    \;

    \ \ <with|color|dark red|def> <with|color|blue|itsPrinting>(o, theFile,
    theIndent=''):

    \ \ \ \ <with|font-family|rm|Writes the structure of the tree to a file.>

    \ \ \ \ <with|font-family|rm|This method is meant as a helper for
    debugging.>

    \ \ \ \ <with|font-family|rm|The file must be an open file in mode
    <verbatim|'w'>.>

    \ \ \ \ w = theFile write

    \ \ \ \ ind = theIndent

    \ \ \ \ w("%s%s {\\n" % (ind, o __class__ __name__))

    \ \ \ \ ind += " \ "

    \ \ \ \ <with|color|dark green|for> child <with|color|dark green|in> o:

    \ \ \ \ \ \ <with|color|dark green|if> child <with|color|dark green|is>
    None:

    \ \ \ \ \ \ \ \ <with|font-family|rm|(error)>

    \ \ \ \ \ \ \ \ w("%sNone (ERROR)\\n" % ind)

    \ \ \ \ \ \ \ \ <with|color|dark green|continue>

    \ \ \ \ \ \ <with|color|dark green|if> child title:

    \ \ \ \ \ \ \ \ <with|font-family|rm|Child is a string>

    \ \ \ \ \ \ \ \ w("%s%s (%d)\\n" % (ind, repr(child[:50]), len(child)))

    \ \ \ \ \ \ <with|color|dark green|else>:

    \ \ \ \ \ \ \ \ child itsPrinting(theFile, ind)

    \ \ \ \ w("%s}\\n" % ind[:-2])

    \;

    <with|color|dark red|class> <with|color|#800080|tm_code>(aTmTree):

    \ \ isCode = True

    \;

    <with|color|dark red|class> <with|color|#800080|tm_document>(aTmTree):

    \ \ isVertical = True

    \ \ isDocument = True

    \;

    <with|color|dark red|class> <with|color|#800080|tm_concat>(aTmTree):

    \ \ isConcat = True

    \;

    <with|color|dark red|class> <with|color|#800080|tm_collection>(aTmTree):

    \ \ isVertical = True

    \ \ isCollection = True

    \;

    <with|color|dark red|class> <with|color|#800080|tm_raw_data>(aTmTree):

    \ \ pass

    \;

    <with|color|dark red|class> <with|color|#800080|tm_with>(aTmTree):

    \ \ isWith = True
  </code>

  <subsection|Automatic creation of other tree classes>

  All tree classes are stored in a singleton dictionary
  <verbatim|TheTmTreeClasses>. Texmacs uses many different node tags, and our
  model is to have a different <verbatim|aTmTree> subclass for each tag. When
  new tags are met, the corresponding class is automatically created when the
  program attempts to access the class through the dictionary of the tree
  classes.

  <\code>
    @@ py tree

    \;

    <with|color|dark red|class> <with|color|#800080|_aTmTreeDictionary>(dict):

    \ \ <with|font-family|rm|Singleton class>

    \ \ <with|color|dark red|def> <with|color|blue|__init__>(o):

    \ \ \ \ <with|font-family|rm|At creation, the dictionary stores all the
    subclasses which exist at module level.>

    \ \ \ \ dict __init__(o, ((k,v) <with|color|dark green|for> (k, v)
    <with|color|dark green|in> globals() items()

    \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ <with|color|dark green|if>
    (type(v) <with|color|dark green|is> type) <with|color|dark green|and>
    issubclass(v, aTmTree)))

    \ \ <with|color|dark red|proc> <with|color|blue|__missing__>(o, theKey):
    <with|font-family|rm|<math|\<leftarrow\>> python <math|\<geqslant\>2.5>.>

    \ \ \ \ <with|font-family|rm|Accessing a missing key creates a new tree
    class.>

    \ \ \ \ <with|color|dark green|if> <with|color|dark green|not> theKey
    startswith("tm_"):

    \ \ \ \ \ \ <with|font-family|rm|Error: trees class names must start with
    <verbatim|tm_> (except for the base class <verbatim|aTmTree>)>

    \ \ \ \ \ \ <with|color|dark green|raise> KeyError(theKey)

    \ \ \ \ theClass = type(theKey, (aTmTree,), {})
    <with|font-family|rm|<math|\<leftarrow\>> create a new class.>

    \ \ \ \ o[theKey] = theClass

    \ \ \ \ <with|color|dark green|return> theClass

    \;

    TheTmTreeClasses = _aTmTreeDictionary()
    <with|font-family|rm|<math|\<leftarrow\>> create the single instance.>
  </code>

  \;

  <action|EXPAND|(quail "expand()")>
</body>

<\initial>
  <\collection>
    <associate|bg-color|#e0e0e0>
    <associate|language|english>
    <associate|magnification|1.1>
    <associate|page-type|# Simply write the paper name. See papersize(5) for
    possible values.>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|auto-1|<tuple|?|?>>
    <associate|auto-2|<tuple|1|?>>
    <associate|auto-3|<tuple|1.1|?>>
    <associate|auto-4|<tuple|1.2|?>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|toc>
      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|Table
      of contents> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-1><vspace|0.5fn>

      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|1.<space|2spc><with|font-family|<quote|tt>|language|<quote|verbatim>|aTmTree>
      objects> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-2><vspace|0.5fn>

      <with|par-left|<quote|1.5fn>|1.1.<space|2spc>Base tree classes
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-3>>

      <with|par-left|<quote|1.5fn>|1.2.<space|2spc>Automatic creation of
      other tree classes <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-4>>
    </associate>
  </collection>
</auxiliary>