<TeXmacs|1.0.6.10>

<style|amsart>

<\body>
  <action|EXPAND|(quail "expand()")>

  <doc-data|<doc-title|write.tm>>

  <\table-of-contents|toc>
    <vspace*|1fn><with|font-series|bold|math-font-series|bold|Table of
    contents> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
    <no-break><pageref|auto-1><vspace|0.5fn>

    <vspace*|1fn><with|font-series|bold|math-font-series|bold|1.<space|2spc>The
    texmacs writer> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
    <no-break><pageref|auto-2><vspace|0.5fn>

    <with|par-left|1.5fn|1.1.<space|2spc>The writer class
    <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
    <no-break><pageref|auto-3>>

    <with|par-left|1.5fn|1.2.<space|2spc>Serializing a document tree
    <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
    <no-break><pageref|auto-4>>

    <with|par-left|1.5fn|1.3.<space|2spc>Serializing a collection tree
    <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
    <no-break><pageref|auto-5>>

    <with|par-left|1.5fn|1.4.<space|2spc>Serializing a raw data tree
    <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
    <no-break><pageref|auto-6>>

    <with|par-left|1.5fn|1.5.<space|2spc>Serializing a concat tree
    <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
    <no-break><pageref|auto-7>>

    <with|par-left|1.5fn|1.6.<space|2spc>Serializing other trees
    <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
    <no-break><pageref|auto-8>>
  </table-of-contents>

  <\code>
    @@ buttons

    <with|color|dark red|def> <with|color|blue|expand>():

    \ \ <with|color|dark green|pass>
  </code>

  <section|The texmacs writer>

  The purpose of the texmacs writer is to <em|serialize texmacs trees> and to
  <em|write files> in the texmacs format. It works in 2 steps

  <\enumerate-numeric>
    <item>Traverse the texmacs tree and produce a serialized string which
    contains special characters to represent typesetting requests (like
    <em|add a blank row>). The writer object uses a buffer (currently
    implemented as a <verbatim|StringIO> object) to store this string.

    <item>Use a typewriter-like algorithm to typeset the actual document,
    using the formatting rules of texmacs and the special characters
    contained in the serialized buffer. The main method
    <verbatim|doTypeset(\<less\>file\<gtr\>)> of the writer object takes a
    file argument, which can be any file-like python object with a
    <verbatim|write(\<less\>string\<gtr\>)> method.
  </enumerate-numeric>

  <subsection|The writer class>

  <\code>
    @@ py writer

    <with|color|dark green|from> quailCenter <with|color|dark green|import>
    doDeclareAlias, quailGet

    doDeclareAlias("", "the texmacs writer module")

    doDeclareAlias("aTexmacsWriter", "the texmacs writer class")

    <with|color|dark green|from> cStringIO <with|color|dark green|import>
    StringIO

    <with|color|dark green|import> binascii

    <with|color|dark green|import> re

    \;

    <with|color|dark red|class> <with|color|#800080|aTexmacsWriter>(object):

    \ \ <with|font-family|rm|<math|\<nearrow\>> The main class to serialize
    texmacs trees and write texmacs files.>

    \ \ NL, BR, CUT = [chr(i) <with|color|dark green|for> i <with|color|dark
    green|in> xrange(1,4)]

    \ \ <with|font-family|rm|<math|\<uparrow\>> Special characters used by
    the writer to encode certain typesetting requests.>

    \ \ BRSHIFT = 2

    \;

    \ \ <with|color|dark red|def> <with|color|blue|__init__>(o):

    \ \ \ \ o _doDecorateTreeClasses()

    \ \ \ \ o itsBuffer = StringIO()

    \ \ \ \ o rawPut = o itsBuffer write

    \ \ \ \ <with|font-family|rm|<math|\<nearrow\>> rawPut \ is a shorthand
    for the buffer's write function.>

    \;

    \ \ @staticmethod

    \ \ <with|color|dark red|def> <with|color|blue|_doDecorateTreeClasses>():

    \ \ \ \ <with|font-family|rm|<math|\<nearrow\>> Add a
    <verbatim|doSerialize> method to some tree classes.>

    \ \ \ \ <with|font-family|rm|This method is called only once when the
    first writer is created.>

    \ \ \ \ aTexmacsWriter _doDecorateTreeClasses = <with|color|dark
    green|lambda> o: None

    \ \ \ \ theTreeModule = quailGet("the texmacs tree module")

    \ \ \ \ <with|color|dark green|for> name <with|color|dark green|in>
    "document collection concat raw_data".split():

    \ \ \ \ \ \ theClass = getattr(theTreeModule, "tm_" + name)

    \ \ \ \ \ \ setattr(theClass, "doSerialize",
    globals()["doSerialize_"+name])

    \ \ \ \ theTreeModule.aTmTree.doSerialize = doSerialize_generic

    \ \ \ \ theEncoderModule = quailGet("the texmacs text encoding module")

    \ \ \ \ globals()["texmacsEncode"] = theEncoderModule texmacsEncode

    \;

    \ \ <with|color|dark red|def> <with|color|blue|doPopBuffer>(o):

    \ \ \ \ <with|font-family|rm|<math|\<nearrow\>> Clear the writer's buffer
    and return its content.>

    \ \ \ \ theContent = o itsBuffer getvalue()

    \ \ \ \ o itsBuffer truncate(0)

    \ \ \ \ <with|color|dark green|return> theContent

    \;

    \ \ <with|color|dark red|def> <with|color|blue|doSerializeItem>(o,
    theItem):

    \ \ \ \ <with|font-family|rm|Serialize a <em|tree item>, which can be a
    string or a subtree.>

    \ \ \ \ <with|color|dark green|if> theItem title:
    <with|font-family|rm|<math|\<leftarrow\>> the item is a string.>

    \ \ \ \ \ \ <with|font-family|rm|Each first space character in a series
    <math|\<swarrow\>> is encoded as a possible cut point.>

    \ \ \ \ \ \ x = texmacsEncode(theItem, o CUT)

    \ \ \ \ \ \ o rawPut(x)

    \ \ \ \ <with|color|dark green|else>:
    <with|font-family|rm|<math|\<leftarrow\>> the item is a subtree.>

    \ \ \ \ \ \ theItem doSerialize(o)

    \;

    \ \ <with|color|dark red|def> <with|color|blue|doSerializeNoCut>(o,
    theString):

    \ \ \ \ <with|font-family|rm|Serialize a <em|string> with space
    characters escaped (they can't be used as cut points)>

    \ \ \ \ s = texmacsEncode(theString, "\\\\ ")

    \ \ \ \ o rawPut(s)

    \;

    \ \ <with|color|dark red|def> <with|color|blue|putNL>(o):

    \ \ \ \ <with|font-family|rm|<math|\<nearrow\>> Add a newline typesetting
    request in the buffer.>

    \ \ \ \ o rawPut(o NL)

    \;

    \ \ <with|color|dark red|def> <with|color|blue|putCut>(o):

    \ \ \ \ <with|font-family|rm|<math|\<nearrow\>> Add a possible cut point
    typesetting request in the buffer.>

    \ \ \ \ o rawPut(o CUT)

    \;

    \ \ <with|color|dark red|def> <with|color|blue|putBR>(o, theIncr):

    \ \ \ \ <with|font-family|rm|<math|\<nearrow\>> Add a blank row request
    in the buffer, with an indentation increment.>

    \ \ \ \ <with|font-family|rm|The increment can be -2, 0 or 2; adding
    <verbatim|BRSHIFT> turns it to 0, 2, 4 (a single char).>

    \ \ \ \ o rawPut(o BR + str(theIncr + o BRSHIFT))

    \;

    \ \ itsRequestPattern = re compile(r"\\x01+\|\\x03+\|\\x02[024]\|$")

    \ \ <with|font-family|rm|<math|\<nearrow\>> This pattern matches the
    typesetting requests characters, and the end of buffer.>

    \;

    \ \ <with|color|dark red|def> <with|color|blue|doSerialize>(o,
    theDocument):

    \ \ \ \ <with|font-family|rm|<math|\<nearrow\>> Serialize a full document
    tree and clean the buffer.>

    \ \ \ \ o doPopBuffer()

    \ \ \ \ theDocument doSerialize(o)

    \ \ \ \ <with|color|dark green|return> o doPopBuffer()

    \;

    \ \ <with|color|dark red|def> <with|color|blue|doTypeset>(o, theDocument,
    theFile):

    \ \ \ \ <with|font-family|rm|<math|\<nearrow\>> This is the writer's main
    method. Serialize a document tree, and write to a file.>

    \;

    \ \ \ \ <with|font-family|rm|A few constants:>

    \ \ \ \ space, espace, newline, empty = " ", "\\\\ ", "\\n", ""

    \ \ \ \ spaces = space * 20

    \;

    \ \ \ \ <with|font-family|rm|Some shortcuts:>

    \ \ \ \ NL, BR, CUT, BRSHIFT = o NL, o BR, o CUT, o BRSHIFT

    \ \ \ \ write = theFile write

    \;

    \ \ \ \ <with|font-family|rm|State variables>

    \ \ \ \ offset = indent = depth = pos = 0

    \ \ \ \ cutSpace = escSpaces = ""

    \ \ \ \ <with|font-family|rm|The writer has a position
    <verbatim|<em|pos>> in the input string (the serialized document).>

    \ \ \ \ <with|font-family|rm|When the writer starts a new line, it
    outputs an indentation of <verbatim|min(20, <em|depth>)>>

    \ \ \ \ <with|font-family|rm|space characters, where the the variable
    <verbatim|<em|depth>> varies when the request to>

    \ \ \ \ <with|font-family|rm|start a new line is read in the input
    string. The indentation of the current>

    \ \ \ \ <with|font-family|rm|line being written is
    <verbatim|<em|indent>>, and the writer's current position in this line>

    \ \ \ \ <with|font-family|rm|is <verbatim|<em|offset><math|\<geqslant\>><em|indent>>.>

    \ \ \ \ <with|font-family|rm|When <verbatim|<em|cutSpace>> is not the
    empty string, it is a space character which can be>

    \ \ \ \ <with|font-family|rm|used by the writer to pass to the line (it
    outputs a newline \ in this case). This>

    \ \ \ \ <with|font-family|rm|cut character can be followed by a sequence
    of escaped space characters which>

    \ \ \ \ <with|font-family|rm|form the string <verbatim|<em|escSpaces>>.
    Conceptually, the cut character and the escaped>

    \ \ \ \ <with|font-family|rm|spaces come just after the position offset
    in the current line (but they may be>

    \ \ \ \ <with|font-family|rm|written in the next line if the writer
    decides to do so).>

    \;

    \ \ \ \ theSerial = o doSerialize(theDocument)

    \ \ \ \ <with|color|dark green|for> match <with|color|dark green|in> o
    itsRequestPattern finditer(theSerial):

    \ \ \ \ \ \ <with|font-family|rm|<math|\<nearrow\>> Loop over all groups
    of special characters in the serialized document.>

    \ \ \ \ \ \ <with|font-family|rm|<math|\<searrow\>> read the unhandled
    input and the special characters matched.>

    \ \ \ \ \ \ newInput, control = theSerial[pos:match.start()], match
    group(0)

    \ \ \ \ \ \ pos = match end() <with|font-family|rm|<math|\<leftarrow\>>
    set the input position for the next iteration.>

    \;

    \ \ \ \ \ \ <with|font-family|rm|<math|\<bullet\>> <with|color|red|Step
    A>: write the new input, possible line break and white space.>

    \ \ \ \ \ \ need = len(escSpaces) + len(newInput)

    \ \ \ \ \ \ <with|color|dark green|if> (cutSpace <with|color|dark
    green|and> need <with|color|dark green|and> (offset \<gtr\> max(40, 76 -
    need))):

    \ \ \ \ \ \ \ \ <with|font-family|rm|<math|\<nearrow\>> line is too long
    and can be broken: break it.>

    \ \ \ \ \ \ \ \ write(newline) <with|font-family|rm|<math|\<leftarrow\>>
    cut space written as a newline.>

    \ \ \ \ \ \ \ \ cutSpace = empty

    \ \ \ \ \ \ \ \ offset = indent

    \ \ \ \ \ \ <with|color|dark green|if> (offset == indent)
    <with|color|dark green|and> (need <with|color|dark green|or> cutSpace):

    \ \ \ \ \ \ \ \ write(spaces[:indent])

    \ \ \ \ \ \ <with|color|dark green|if> cutSpace:

    \ \ \ \ \ \ \ \ cutSpace = empty

    \ \ \ \ \ \ \ \ <with|color|dark green|if> (offset \<gtr\> indent)
    <with|color|dark green|and> need:

    \ \ \ \ \ \ \ \ \ \ write(space) <with|font-family|rm|<math|\<leftarrow\>>
    cut space written as a space.>

    \ \ \ \ \ \ \ \ \ \ offset += 1

    \ \ \ \ \ \ \ \ <with|color|dark green|else>:

    \ \ \ \ \ \ \ \ \ \ write(espace) <with|font-family|rm|<math|\<leftarrow\>>
    cut space written as an escaped space.>

    \ \ \ \ \ \ \ \ \ \ offset += 2

    \ \ \ \ \ \ write(escSpaces)

    \ \ \ \ \ \ escSpaces = empty

    \ \ \ \ \ \ write(newInput)

    \ \ \ \ \ \ offset += need

    \;

    \ \ \ \ \ \ <with|font-family|rm|<math|\<bullet\>> <with|color|red|Step
    B>: handle the special characters (typesetting requests).>

    \ \ \ \ \ \ c = control[:1] <with|font-family|rm|<math|\<leftarrow\>>the
    first character in the match (empty on eof).>

    \ \ \ \ \ \ <with|color|dark green|if> c == CUT:
    <with|font-family|rm|<math|\<leftarrow\>> the control is a sequence of
    space characters.>

    \ \ \ \ \ \ \ \ cutSpace = space

    \ \ \ \ \ \ \ \ i = len(control) - 1

    \ \ \ \ \ \ \ \ escSpaces = espace * i <with|color|dark green|if> (i)
    <with|color|dark green|else> empty

    \ \ \ \ \ \ <with|color|dark green|elif> c == NL:
    <with|font-family|rm|<math|\<leftarrow\>>means <em|add an empty line
    between 2 paragraphs>.>

    \ \ \ \ \ \ \ \ write(newline * 2 <with|color|dark green|if> (offset
    \<gtr\> indent) <with|color|dark green|else> newline)

    \ \ \ \ \ \ \ \ offset = indent

    \ \ \ \ \ \ <with|color|dark green|elif> c == BR:
    <with|font-family|rm|<math|\<leftarrow\>><em|go to the beginning of a
    line and set indentation.>>

    \ \ \ \ \ \ \ \ <with|color|dark green|if> offset \<gtr\> indent:
    <with|font-family|rm|<math|\<leftarrow\>>current line is not empty>

    \ \ \ \ \ \ \ \ \ \ write(newline)

    \ \ \ \ \ \ \ \ depth += int(control[1]) - BRSHIFT

    \ \ \ \ \ \ \ \ offset = indent = min(20, depth)
  </code>

  <subsection|Serializing a document tree>

  <\code>
    @@ py writer

    \;

    <with|color|dark red|def> <with|color|blue|doSerialize_document>(theDocument,
    theWriter):

    \ \ rawPut = theWriter rawPut

    \ \ doSerializeItem = theWriter doSerializeItem

    \ \ putNL = theWriter putNL

    \ \ <with|color|dark green|if> theDocument[0] title <with|color|dark
    green|and> <with|color|dark green|not> theDocument[0]:

    \ \ \ \ <with|font-family|rm|<math|\<nearrow\>> The first paragraph is an
    empty string.>

    \ \ \ \ rawPut(r"\\;")

    \ \ <with|color|dark green|else>:

    \ \ \ \ doSerializeItem(theDocument[0])

    \ \ <with|color|dark green|for> item <with|color|dark green|in>
    theDocument[1:]:

    \ \ \ \ putNL() <with|font-family|rm|<math|\<leftarrow\>> add an empty
    line before subsequent paragraphs.>

    \ \ \ \ <with|color|dark green|if> item title <with|color|dark green|and>
    <with|color|dark green|not> item:

    \ \ \ \ \ \ rawPut(r"\\;")

    \ \ \ \ <with|color|dark green|else>:

    \ \ \ \ \ \ doSerializeItem(item)
  </code>

  <subsection|Serializing a collection tree>

  <\code>
    @@ py writer

    \;

    <with|color|dark red|def> <with|color|blue|doSerialize_collection>(theCollection,
    theWriter):

    \ \ rawPut = theWriter rawPut

    \ \ putBR = theWriter putBR

    \ \ doSerializeItem = theWriter doSerializeItem

    \ \ rawPut(r"\<less\>\\collection\<gtr\>")

    \ \ <with|color|dark green|if> len(theCollection):

    \ \ \ \ putBR(2) <with|font-family|rm|<math|\<leftarrow\>>start a new
    line with increased indentation.>

    \ \ \ \ <with|color|dark green|for> item <with|color|dark green|in>
    theCollection[:-1]:

    \ \ \ \ \ \ doSerializeItem(item)

    \ \ \ \ \ \ putBR(0) <with|font-family|rm|<math|\<leftarrow\>>start a new
    line between the collection's items>

    \ \ \ \ doSerializeItem(theCollection[-1])

    \ \ \ \ putBR(-2) <with|font-family|rm|<math|\<leftarrow\>> start a new
    line with the initial indentation.>

    \ \ <with|color|dark green|else>: <with|font-family|rm|<math|\<leftarrow\>>
    the collection is empty>

    \ \ \ \ putBR(0)

    \ \ rawPut(r"\<less\>/collection\<gtr\>")
  </code>

  <subsection|Serializing a raw data tree>

  <\code>
    @@ py writer

    \;

    <with|color|dark red|def> <with|color|blue|doSerialize_raw_data>(theRawData,
    theWriter):

    \ \ rawPut = theWriter rawPut

    \ \ rawPut("\<less\>#")

    \ \ rawPut(binascii.hexlify(theRawData[0]))

    \ \ rawPut("\<gtr\>")
  </code>

  <subsection|Serializing a concat tree>

  <\code>
    @@ py writer

    \;

    <with|color|dark red|def> <with|color|blue|doSerialize_concat>(theConcat,
    theWriter):

    \ \ doSerializeItem = theWriter doSerializeItem

    \ \ <with|color|dark green|for> item <with|color|dark green|in>
    theConcat:

    \ \ \ \ doSerializeItem(item)
  </code>

  <subsection|Serializing other trees>

  This is the generic serializing method for the base class of texmacs trees

  <\code>
    @@ py writer

    \;

    <with|color|dark red|def> <with|color|blue|doSerialize_generic>(theTree,
    theWriter):

    \ \ rawPut = theWriter rawPut

    \ \ doSerializeItem = theWriter doSerializeItem

    \ \ putBR = theWriter putBR

    \ \ theName = texmacsEncode(

    \ \ \ \ \ \ \ \ \ theTree wordToTmTag(theTree __class__ __name__), "\\\\
    ")

    \ \ lastVertical = None <with|font-family|rm|<math|\<leftarrow\>> the
    index of the last verticaly serialized child node.>

    \ \ <with|color|dark green|for> i <with|color|dark green|in>
    xrange(len(theTree)-1, -1, -1):

    \ \ \ \ <with|color|dark green|if> (<with|color|dark green|not>
    theTree[i] title) <with|color|dark green|and> theTree[i] isVertical:

    \ \ \ \ \ \ lastVertical = i

    \ \ \ \ \ \ <with|color|dark green|break>

    \ \ rawPut("\<less\>" <with|color|dark green|if> (lastVertical
    <with|color|dark green|is> None) <with|color|dark green|else>
    "\<less\>\\\\"); rawPut(theName)

    \ \ <with|color|dark green|for> i, theItem <with|color|dark green|in>
    enumerate(theTree):

    \ \ \ \ <with|color|dark green|if> (not theItem title) and theItem
    isVertical:

    \ \ \ \ \ \ \ <with|font-family|rm|The item must be serialized vertically
    <math|\<nearrow\>>>

    \ \ \ \ \ \ rawPut("\<gtr\>"); putBR(2); doSerializeItem(theItem);
    putBR(-2)

    \ \ \ \ \ \ rawPut("\<less\>\|" <with|color|dark green|if> (i \<less\>
    lastVertical) <with|color|dark green|else> "\<less\>/"); rawPut(theName)

    \ \ \ \ <with|color|dark green|else>:

    \ \ \ \ \ \ rawPut("\|"); doSerializeItem(theItem)

    \ \ rawPut("\<gtr\>")
  </code>

  \;

  <action|EXPAND|(quail "expand()")>
</body>

<\initial>
  <\collection>
    <associate|bg-color|#e0e0e0>
    <associate|language|english>
    <associate|magnification|1.1>
    <associate|page-type|# Simply write the paper name. See papersize(5) for
    possible values.>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|auto-1|<tuple|?|?>>
    <associate|auto-2|<tuple|1|?>>
    <associate|auto-3|<tuple|1.1|?>>
    <associate|auto-4|<tuple|1.2|?>>
    <associate|auto-5|<tuple|1.3|?>>
    <associate|auto-6|<tuple|1.4|?>>
    <associate|auto-7|<tuple|1.5|?>>
    <associate|auto-8|<tuple|1.6|?>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|toc>
      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|Table
      of contents> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-1><vspace|0.5fn>

      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|1.<space|2spc>The
      texmacs writer> <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-2><vspace|0.5fn>

      <with|par-left|<quote|1.5fn>|1.1.<space|2spc>The writer class
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-3>>

      <with|par-left|<quote|1.5fn>|1.2.<space|2spc>Serializing a document
      tree <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-4>>

      <with|par-left|<quote|1.5fn>|1.3.<space|2spc>Serializing a collection
      tree <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-5>>

      <with|par-left|<quote|1.5fn>|1.4.<space|2spc>Serializing a raw data
      tree <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-6>>

      <with|par-left|<quote|1.5fn>|1.5.<space|2spc>Serializing a concat tree
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-7>>

      <with|par-left|<quote|1.5fn>|1.6.<space|2spc>Serializing other trees
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-8>>
    </associate>
  </collection>
</auxiliary>